
#include "DemoEventHandler.h"

DemoEventHandler::DemoEventHandler() : GUIEventListener(), red(0), green(0), blue(0) { }

void DemoEventHandler::actionPerformed(GUIEvent &evt)
{


  static int num  = 0;
  char charBuffer[50];
  const std::string &callbackString  = evt.getCallbackString();
  GUIRectangle      *sourceRectangle = evt.getEventSource(),
                    *parent          = sourceRectangle ? sourceRectangle->getParent() : NULL;
  int                widgetType      = sourceRectangle->getWidgetType();

  if(widgetType == WT_SLIDER)
  {
    GUISlider  *slider = (GUISlider*)sourceRectangle;

	if (slider->isClicked() || slider->isPressed()) {
    if(callbackString == "s1" || callbackString == "s2")
    {
      sprintf(charBuffer, "%s: %.2f",  (callbackString == "s1") ? "Slider 1" : "Slider 2",  slider->getProgress());
      slider->setLabelString(charBuffer);
    }

    if(callbackString == "red")   this->red   = slider->getProgress();
    if(callbackString == "blue")  this->blue  = slider->getProgress();
    if(callbackString == "green") this->green = slider->getProgress();
	}
  }

  if(widgetType == WT_CHECK_BOX)
  {
		GUICheckBox   *checkBox = (GUICheckBox*)sourceRectangle;
		if (checkBox->isClicked()) {
			if(callbackString == "cb_red") {

				if (checkBox->isChecked()) red = 1.0;
				else red = 0.0;
			
			}
			else if(callbackString == "cb_green") {

				if (checkBox->isChecked()) green = 1.0;
				else green = 0.0;
			
			}
			else if(callbackString == "cb_blue") {

				if (checkBox->isChecked()) blue = 1.0;
				else blue = 0.0;
			}
		}
  }

  if(widgetType == WT_RADIO_BUTTON)
  {
		GUIRadioButton   *radioButton = (GUIRadioButton*)sourceRectangle;
		if (radioButton->isClicked()) {
			if(callbackString == "rb_red") {
				red = 1.0;
				green = 0.0;
				blue = 0.0;
			}
			else if(callbackString == "rb_green") {
				red = 0;
				green = 1.0;
				blue = 0;
			}
			else if(callbackString == "rb_blue") {
				red = 0;
				green = 0;
				blue = 1.0;
			}
		}
  }


  if(widgetType == WT_BUTTON)
  {
    GUIButton   *button = (GUIButton*)sourceRectangle;
    if(callbackString == "exit" && button->isClicked())
        exit(0);

	if(callbackString == "continue" && button->isClicked()) {

		while (parent != NULL) {
			sourceRectangle = parent;
			parent = sourceRectangle->getParent();
		}

		GUIFrame * frame = (GUIFrame *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("splash");
		if (frame) frame->setVisible(false);

		frame = (GUIFrame *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("fpsPanel");
		if (frame) frame->setVisible(true);
		frame = (GUIFrame *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("colorSliders");
		if (frame) frame->setVisible(true);
		frame = (GUIFrame *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("tabs");
		if (frame) frame->setVisible(true);

	}
  }

  if(widgetType == WT_COMBO_BOX)
  {
    GUIComboBox  *comboBox = (GUIComboBox*)sourceRectangle;
    if(callbackString == "cb1")
    if(comboBox->getSelectedItem() == std::string("Select this item to exit"))
      exit(0);
  }


}


