#ifndef _GUI_WRAPPER_H
#define _GUI_WRAPPER_H

// Forward declare GLWX objects
class GUIEventListener;
class GUILabel;
class GUIFrame;


class GuiWrapper {

public:


	GuiWrapper(GUIEventListener * eventHandler);
	~GuiWrapper();

	bool MouseClicked(int button, bool isDown, int x, int y) ;
	bool MouseMoved(int x, int y);
	bool AsciiKeyDown(unsigned char key);
	bool SpecialKeyDown(int key);
	bool Init(const char * dataPath);
	void SetDimensions(int width, int height);
	void RenderScene();
	void Update(double dt);
	bool IsActive();
	void SetActive( bool active );

private:

	void Enter2DMode(int width, int height);
	void Exit2DMode();

	GUIEventListener *handler;
	GUILabel     *fpsDisplay;
	GUIFrame      *guiFrame;

	bool isActive;
	double dt;
	double elapsed;
	double fps;
	int frames;

};



#endif
