
#include "EventHandler.h"
#include "lattice.h"

EventHandler::EventHandler(Lattice * lattice) : GUIEventListener(), red(0), green(0), blue(0)
{
	this->lattice = lattice;
}

void EventHandler::actionPerformed(GUIEvent &evt)
{


  static int num  = 0;
  char charBuffer[50];
  const std::string &callbackString  = evt.getCallbackString();
  GUIRectangle      *sourceRectangle = evt.getEventSource(),
                    *parent          = sourceRectangle ? sourceRectangle->getParent() : NULL;
  int                widgetType      = sourceRectangle->getWidgetType();

  if(widgetType == WT_SLIDER)
  {
    GUISlider  *slider = (GUISlider*)sourceRectangle;

	if (slider->isClicked() || slider->isPressed()) {

    if(callbackString == "speed_slider")
    {
		int value = (int)(slider->getProgress()*40.0);
		lattice->dSpeed = value;
    }

    if(callbackString == "fov_slider")
    {
		int value = (int)(slider->getProgress()*150.0 + 20);
		lattice->dFov = value;
		lattice->hack_reshape();
    }

	}
  }



  

  if(widgetType == WT_BUTTON)
  {
    GUIButton   *button = (GUIButton*)sourceRectangle;
    if(callbackString == "exit" && button->isClicked())
        exit(0);

	if(callbackString == "apply_button" && button->isClicked()) {


		//Get the root frame
		while (parent != NULL) {
			sourceRectangle = parent;
			parent = sourceRectangle->getParent();
		}

		GUISlider * slider;

		// Get the density slider and set the density value.
		slider = (GUISlider *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("density_slider");
		if (slider)  lattice->dDensity = (int)(slider->getProgress()*100.0);

		// Get the density slider and set the thickness value.
		slider = (GUISlider *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("thickness_slider");
		if (slider)  lattice->dThick = (int)(slider->getProgress()*200.0);

		// Get the density slider and set the longitude value.
		slider = (GUISlider *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("longitude_slider");
		if (slider)  lattice->dLongitude = (int)(slider->getProgress()*100.0);

		// Get the density slider and set the latitude value.
		slider = (GUISlider *)((GUIFrame *)sourceRectangle)->getWidgetByCallbackString("latitude_slider");
		if (slider)  lattice->dLatitude = (int)(slider->getProgress()*100.0);




		lattice->hack_cleanup();
		lattice->SetTexture(lattice->dTexture);
		lattice->makeLatticeObjects();


	}
  }

  if(widgetType == WT_COMBO_BOX)
  {
    GUIComboBox  *comboBox = (GUIComboBox*)sourceRectangle;
    if(callbackString == "texture_combo") {
		int index = comboBox->getItemIndex(comboBox->getSelectedItem());
		index += 1;
		lattice->SetTexture(index);
	}

    if(callbackString == "preset_combo") {
		int index = comboBox->getItemIndex(comboBox->getSelectedItem());
		index += 1;
		lattice->hack_cleanup();
		lattice->setDefaults(index);
		lattice->SetTexture(lattice->dTexture);
		lattice->makeLatticeObjects();
	}
  }


if(widgetType == WT_CHECK_BOX)
  {
		GUICheckBox   *checkBox = (GUICheckBox*)sourceRectangle;
		if (checkBox->isClicked()) {
			if(callbackString == "smooth_shading_check") {

				if (checkBox->isChecked()) lattice->dSmooth = 1;
				else lattice->dSmooth = 0;
			
			}
		}
  }


}


