#ifndef LATTICE_H
#define LATTICE_H

#include "LatticeConfig.h"

#include <stdlib.h>
#include <stdio.h>

#if defined(_WIN32)
#define ATTR_ALIGN(x)
#else
#define ATTR_ALIGN(x) __attribute__ ((aligned(x)))
#endif

#ifdef HAVE_GETOPT_H
#include <getopt.h>
#else
#ifdef HAVE_GETOPT
#include <unistd.h>
#endif
#endif

typedef struct {
	float cullVec[4][4];
	float farplane;
} camera;

class Lattice {

public:
int dLongitude;
int dLatitude;
int dThick;
int dDensity;
int dDrawdepth;
int dFov;
int dPathrand;
int dSpeed;
int dTexture;
int dSmooth;
int dFog;


void hack_init (int width, int height);
void hack_reshape (int width, int height);
void hack_reshape ();
void hack_draw (double);
void hack_cleanup ();
void makeLatticeObjects ();
void SetTexture(int texture);
void setDefaults (int which);
void reconfigure ();

private:

float interpolate (float a, float b, float c, float d, float where);
void camera_init (camera * c, float *mat, float f);
void initTextures ();
void makeTorus (int smooth, int longitude, int latitude, float centerradius, float thickradius);
void setMaterialAttribs();
void draw ();

unsigned char * LoadBinaryTexture(const char * filename);
void FreeBinaryTexture(unsigned char * mem);


};



#endif //LATTICE_H
