
#include "EventHandler.h"
#include "Lights.h"

EventHandler::EventHandler(Lights * lights) : GUIEventListener()
{
	this->lights = lights;
}

void EventHandler::actionPerformed(GUIEvent &evt)
{


  static int num  = 0;
  char charBuffer[50];
  const std::string &callbackString  = evt.getCallbackString();
  GUIRectangle      *sourceRectangle = evt.getEventSource(),
                    *parent          = sourceRectangle ? sourceRectangle->getParent() : NULL;
  int                widgetType      = sourceRectangle->getWidgetType();

  if(widgetType == WT_SLIDER)
  {
    GUISlider  *slider = (GUISlider*)sourceRectangle;

	if (slider->isClicked() || slider->isPressed()) {

    	if(callbackString == "number_slider")
    	{
			double value = slider->getProgress()*100.0;
			lights->SetNumberOfLights(value);
    	}
	
	    if(callbackString == "height_slider")
	    {
			double value = slider->getProgress()*5.0;
			lights->SetHeightAboveGround(value);
	    }

	    if(callbackString == "distance_slider")
	    {
			double value = slider->getProgress()*5.0;
			lights->SetDistanceBetweenLights(value);
	    }

	    if(callbackString == "zoom_slider")
	    {
			double value = slider->getProgress()*50.0;
			lights->SetViewDistance(value-25);
	    }



	}
  }



  

  if(widgetType == WT_BUTTON)
  {
    GUIButton   *button = (GUIButton*)sourceRectangle;
    if(callbackString == "exit" && button->isClicked())
        exit(0);

    if(callbackString == "reset_button" && button->isClicked())
        lights->Reset();

  }


if(widgetType == WT_CHECK_BOX)
  {
		GUICheckBox   *checkBox = (GUICheckBox*)sourceRectangle;
		if (checkBox->isClicked()) {
			if(callbackString == "draw_lines_check") {

				if (checkBox->isChecked()) lights->SetDrawLines(true);
				else lights->SetDrawLines(false);
			}

			if(callbackString == "depth_check") {

				if (checkBox->isChecked()) lights->SetUseDepthBuffer(true);
				else lights->SetUseDepthBuffer(false);
			}
		}
  }


}


