#ifndef LIGHTS_H_
#define LIGHTS_H_

#include "glwx.h"

class Lights {


public:

	Lights();

	bool Init();
	void Draw();

	void SetNumberOfLights(int num);
	void SetDistanceBetweenLights(double distance);
	void SetHeightAboveGround(double height);
	void SetViewDistance(double distance);
	void SetDrawLines(bool flag);
	void SetUseDepthBuffer(bool flag);

	void Reset();

	void MouseDown();
	void MouseUp();
	void MouseMove(int x, int y);

	int GetNumberOfLights();
	double GetDistanceBetweenLights();
	double GetHeightAboveGround();
	double GetP1Brightness();
	double GetP2Brightness();
	double GetPercentDifference();


private:

	bool drawLines;
	int numLights;
	double distance;
	double height;
	double p1Brightness;
	double p2Brightness;
	double percentDifference;
	Texture lightTex;
	Texture textures_skybox[6];
	double cameraPosition[3];
	double lookPosition[3];
	bool mouseIsDown;
	bool isWireframe;
	bool useDepthBuffer;

	void DrawLights();
	void DrawFloor();
	void DrawLines();
	
	void CalculateBrightness();

	


};

#endif
