#include "glwx.h"

bool GUIFont::build()
{
  if(!getName().size())
    return Logger::writeErrorLog("Null font path");
  
  return font.load(getName().c_str());
}

bool GUIFont::loadXMLSettings(const TiXmlElement *element)
{
  if(!XMLArbiter::inspectElementInfo(element, "Font"))
    return Logger::writeErrorLog("Need a Font node in the xml file");

  std::string path = element->Attribute("path");

  std::string fontpath = MediaPathManager::lookUpMediaPath(path);

  if(!fontpath.size())
    return Logger::writeErrorLog(std::string("Couldn't locate the font path at <") + path + "> even with a look up");

  setName(fontpath);

  return true;
}

CFont *GUIFont::getFontObject()
{
  return &font;
}

bool  GUIFont::operator ==(const GUIFont &compare)
{
  return (name   == compare.getName());  
}

bool  GUIFont::operator !=(const GUIFont &compare)
{
  return !operator ==(compare);  
}

GUIFont::~GUIFont()
{

}
